//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Detect.h"
#include "aiousb.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDetectForm *DetectForm;
//---------------------------------------------------------------------------
__fastcall TDetectForm::TDetectForm(TComponent* Owner)
        : TForm(Owner)
{
        DetectButton->Click();
        DeviceList->ItemIndex = 0;
}
//---------------------------------------------------------------------------


void __fastcall TDetectForm::GoButtonClick(TObject *Sender)
{
        //do stuff
        DeviceIndex = DeviceList->ItemIndex;
        ModalResult = mrOk;
}
//---------------------------------------------------------------------------

void __fastcall TDetectForm::DetectButtonClick(TObject *Sender)
{
        unsigned long DeviceMask, PID;
        int I;
        Boolean Found;
        AnsiString Nom;

        DeviceList->Clear();

        Found = false;

        DeviceMask = GetDevices();

        for (I=0; I < 8; I++)
        {
                DeviceOK[I] = false;

                if (DeviceMask & (1 << I))
                {
                        QueryDeviceInfo(I, &PID, NULL, NULL, NULL, NULL);

                        switch (PID)
                        {
                                case 0x8018:
                                        Nom = "USB-IDIO-16";
                                        DeviceOK[I] = TRUE;
                                        Found = TRUE;
                                        break;
                                default :
                                        Nom = "<not for this sample>";
                        }
                }
                else
                {
                        Nom = "<no device at this Index>";
                }

                DeviceList->Items->Add(Nom);
        }

        if (Found)
        {
                StatusMemo->Lines->Add("Select the device you want to work with and click Go.");
        }
        else
        {
                StatusMemo->Lines->Add("No compatible devices found; your device may not be installed, or may not be installed properly. Click Redetect to check again.");
        }
}
//---------------------------------------------------------------------------

